Leetcode 292. Nim Game

292. Nim Game

Description

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

Example:

Input: 4
Output: false 
Explanation: If there are 4 stones in the heap, then you will never win the game;
             No matter 1, 2, or 3 stones you remove, the last stone will always be 
             removed by your friend.

Solution

题意是给定一堆石头,两个人轮流玩,每个人可以选择移除 1 到 3 个石头,最终将石头全部移除的人获胜。这一题是典型的 Game Theory 题目,每个人都做出对自己最优的选择。

当石头数量小于 3 的时候,第一个玩家一定会赢。

当有 N个石头时,第一个玩家能不能赢取决于,当有 N-1N-2N-3 个石头时,第二个玩家是否能赢。如果三种情况下第二个玩家都能获胜,则第一个玩家无法取胜。否则,第一个玩家可以选择移除使第二个玩家不能获胜的石头个数,已达到让自己取胜。

class Solution {
public:
    bool canWinNim(int n) {
        if (n <= 3) {
            return true;
        }
        
        bool m1 = true;
        bool m2 = true;
        bool m3 = true;
        bool cur = false;
        
        for (int i = 4; i <= n; ++i) {
            if (m1 && m2 && m3) {  // 三种情况另一个玩家都能取胜,则当前玩家无法取胜
                cur = false;
            } else {
                cur = true;
            }
            m1 = m2;
            m2 = m3;
            m3 = cur;
        }
        
        return cur;
    }
}

但是,提交之后发现超时了,经过观察后发现只要 N 不是 4 的倍数时,第一个玩家就一定能取胜。

class Solution {
public:
    bool canWinNim(int n) {
        return n % 4 != 0;
    }
}

猜你喜欢

转载自www.cnblogs.com/wuhanqing/p/9397181.html
今日推荐